/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of file
*/
/* make handbook */

#include "readfile.c"

#ifdef	_STDIO_H
#include <unistd.h>
#define	stricmp	strcasecmp
#define DIV_CH   '/'
#else
#include <dos.h>
#define DIV_CH   '\\'
#endif

#include <time.h>
#include <sys/stat.h>
#include "memstr.c"

static const char memblkcmp[]={ 10, 32, 9, ',' , ';' , 0};

static int ToNextLen(const char *pt)
{
  int i;
  for(i=0; strchr("\r\n\t ",pt[i]); i++);
  return i;
}

int main(int argc,char **argv)
{
static const char usageChs[]="Usage : mkhb [hbfile] |[sortfile] |[--dvp] |[--case] |[--void] |[--free] |[-d outdir]\n\
\t--dvp   out pure text file, else out is fsplus-script\n\
\t--case   file-data compare case\n\
\t--void  specied type is void\n\
\t--free  cut 2 side [Enter] or [Space] [tab]\n\
	default is cvt dos-mode to Unix-mode(t)\n\
\t-d   specied dir follow as out !\n\
\nFreely txt-mode, separator is 2[Enter]\n\n";

if(argc>1){
#define  para_cnt  5
  FILE *fout;
  static const char *params[para_cnt]={ "--dvp", "--case", "--void", "--free", "-d" };
  static char sw[para_cnt];
  const char *srcfile=NULL, *idxfile=NULL, *dstdir=NULL;
  char *idxbuf, **DScpt, *pt, *ptr, type='t',
	outfile[1024], buff[80];
  unsigned int idxlen, src_cnt, src_len, i, j, b, sc,
	cmplen, wlen, nxlen, nmb=0;
  struct stat st;
  for(i=1;i<argc;i++){
	pt=argv[i];
	for(j=0; j<para_cnt; j++)
		if(stricmp(pt,params[j])==0){
		    if(j==(para_cnt-1)){
			if(i+1>=argc)goto _setShow_; /* error will show after. */
			if(stat(argv[i+1], &st)==0&&(st.st_mode&S_IFDIR)){
				if(dstdir){
					printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, argv[i+1]);
					break;
				}
				dstdir=argv[++i];
				}
			else {
				printf("\"-d\" specied \"%s\" is not existed dir !\n", argv[i+1]);
				break;
				}
		     }
		     _setShow_:	switch(j){
				case 2 : type='v';
					break;
				case 3 : type='y';
					break;
				default : sw[j]=1;
				}
		     break;
		}

	if(j>(para_cnt-1) && dstdir!=pt){
		if(srcfile==NULL){
			if(stat(pt, &st)==0&&!(st.st_mode&S_IFDIR))srcfile=pt;
			else goto _err_;
			}
		else if(idxfile==NULL){
			if(stat(pt, &st)==0&&!(st.st_mode&S_IFDIR))idxfile=pt;
			else goto _err_;
			}
		     else _err_: printf("%s is unuseful params\n", pt);
	}
    }
  
  pt=strchr(*argv,DIV_CH);
  if(pt){ _ProgPath=*argv; *pt=0; }

  if(idxfile && !(idxbuf=ReadFile(idxfile, &idxlen)) )
	return 3;

/*=========== get descript(poors) begin ===================*/
 if(srcfile==NULL){
	printf("No src file !\n%s",usageChs);
	return 1;
	}
 if( !(pt=ReadFile(srcfile,&src_len))) return 2; 
 for(pt[src_len]=0,i=src_len-1;i>0&&pt[i]==10;i--,src_len--)pt[i]=0;
 for(src_cnt=1,i=0;i<src_len;i++)
	if(pt[i]==10 && pt[i+1]==10 ){
		src_cnt++; pt[i]=0;
		if(i<src_len){
		  j=ToNextLen(pt+i+2);
		  if(j>0)i+=j-1;/* as i++ in loop */
		}
	}
 DScpt=(char **)malloc(src_cnt*sizeof(char *));
 *DScpt=pt;
 for(j=1,i=0; i<src_len&&j<src_cnt; i++)if(pt[i]==0){
	nxlen=ToNextLen(pt+i);
	DScpt[j++]=pt+i+nxlen;
/*	printf("nx=%d, %s",i+nxlen,DScpt[j-1]);*/
 }
/*=========== get descript(poors) end ======================*/

  if(sw[para_cnt-1]){
	if(dstdir){
		int L=strlen(dstdir);
		scopy(outfile, dstdir);
		pt=strrchr(srcfile, DIV_CH);
		if(pt){
			if(dstdir[L-1]==DIV_CH)L--;
			scopy(outfile+L, pt);
		}
		else { outfile[L++]=DIV_CH; scopy(outfile+L, srcfile); }
		}
/*		goto _skp_; */
	else {
		printf("A dir must follow \"-d\" for out !\n");
		goto _setsrc_;
	}
	}
  else  _setsrc_: scopy(outfile, srcfile);
  pt=strrchr(outfile,'.');
  if(pt)scopy(pt,".out");
  fout=fopen(outfile,"wb");
  if(idxfile)idxlen++;
  else goto _src_lists_;
  for(sc=0,i=0,b=0; i<idxlen && sc<src_cnt; i++)
    if(strchr(memblkcmp,idxbuf[i])){
    pt=idxbuf+b;
    cmplen=i-b;
    idxbuf[i]=0; b=i+1;
    if(cmplen>0){
_src_lists_:
	for(j=0;j<src_cnt;j++){/* src-lists */
	  ptr=DScpt[j];
	  if(idxfile==NULL || (
		ptr[cmplen]==':'&&memstr(ptr,cmplen,pt,cmplen,1|(sw[1]*2))) ){
	    wlen=strlen(ptr);	sc++;
	    if(ptr[wlen-1]!='\n'){
		ptr[wlen]='\n';	wlen++;
		}
	/*    if(cn<n){ ptr[wlen]='\n'; wlen++; }*/
	    if(*sw/* "--dvp" */){
		while(*ptr!=10){
			ptr++;		wlen--;
			}
		wlen--;
		if(*ptr==10)ptr++;
	    }
	    fprintf(fout,"numbset %d -t=%c  -l=%d\n{\n", nmb, type, wlen-1);
	    fwrite(ptr,wlen,1,fout);
	    fwrite("}\n\n",3,1,fout);
	    if(idxfile)break;
	    else nmb++;
	   }
       }/* src-lists end */
       if(idxfile==NULL)goto _ex_;
       if(j>=src_cnt){ 
		static const char endchs[]=": ...\n}\n\n";
		fprintf(fout,"numbset %d -t=t\n{\n", nmb);
		fwrite(pt,cmplen,1,fout);
		fwrite(endchs,sizeof(endchs)-1,1,fout);
		}
	nmb++;
    }
    else break;
  }
/*  free(idxbuf); redure code */
/* free(*DScpt);free(DScpt); */
_ex_: fclose(fout);
  printf("Create \"%s\" successfully\n",outfile);
  return 0; /* for make.exe */
}
printf(usageChs);
return 100;
}
