/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Copyright 林江卄17
	Reserve all rights of this file
*/

#include "c_lib.h"
#include "script.h"
#include "normlib.h"
#include "jxswitch.h"
#include "rtlcom.h"
#include "filecon.h"
#include "dire.h"

RunTimLib *workspace[SPACELIMIT];/* must reserve 2 file for other use */

const char rundat[2][12]={"runtime.en","runtime.cn"};
char Buff[480];

#ifdef  _STDIO_H
char **_argv;
#else
static const _Int ComMsg[FastKey+4+1]={ ENTER, ESC, ALT_X, ALT_Q, /* FAST KEY POS =4 */
 F1, ALT_F1, F5, F4, F2, F6, F7, F8, F9,ALT_F9, F10, SHF_F1, 0 };
static const char *FastCmd[FastKey]={"help", "help -all", "selspace -20", "selspace -22",
	"info", "list", "dir", "export . -F8","compress -F9","compress.fit -F9","closeall","fastkey"};
#endif

int main(int argc,char **argv)
{
int i, j, n=0;
RunTimLib *lib=NULL;
char *pth, *buffer=Buff, *ptr;

#ifndef	_STDIO_H
clear();
PrnTxt(4,1,50,1,libver);
#else
printf("\033[2J");
printf("\033[1;1H");
PrnTxt(4,-1,50,34,libver);
_argv=argv;
#endif

puts(SPC);

popMsg=putmsg;
progpath=(const char **)envpath(*argv,NULL);/* for read runtime, must done once here */
for(i=1;i<argc;i++)
	if((n=GetComm(argv[i],"--en,--zh_cn",confval,NULL))!=-400)
		for(argc--;i<argc;i++)argv[i]=argv[i+1];
if(n==-400)n=0;
RTLinstance(rundat[n],8/* read first dir in root as curdir */|16384/* use for space[0]*/);
if(libmanu){
  comchs=GetManu(CMDCHR);
  if(comchs==NULL){ ptr="\nFail to get COMMAND in %s\n"; goto errMsg; }
/*  else while(*comchs==10||*comchs==13||*comchs==32||*comchs==9)comchs++;*/
  kval=(_Int *)GetManu(CMDNMB);
  if((pth=sysIdRead(*workspace, 2))!=NULL){ /* read self-path */
	free((void *)progpath[0]);	free((void **)progpath);
	cnt_path=0; progpath=(const char **)envpath(*argv,pth);
	free(pth);
	}
  InpBuf=buffer;
  {
	time_t t1;
	time(&t1);
	sprintf(buffer,"Program init: %s", ctime(&t1) );
  }
  RunLog(buffer);

  if(argc>1){ j=0;	i=1;
    LOOP: if(stricmp(argv[i],"-Alt_X")==0){ ModeVal=264; goto _Loop; }
      scopy(buffer+j,argv[i]);
      j=strlen(buffer);
      _Loop: if(++i<argc){ buffer[j++]=' ';	goto LOOP; }
/* LOOP end */
    if(ModeVal==264){ lib=Comjxor(NULL,buffer); goto ex; }
  }
 
  if((ptr=sysIdRead(*workspace, 3))!=NULL){ /* config */
    char **plst;
    _Int cmd;
    pth=GetManu(65); /* get sys-config-commands */
    if(pth){
	i=80;
	plst=SetArgv(ptr,&i, "\r\n,;");
	for(j=0;j<i;j++){
	  cmd=GetComm(plst[j],pth,confval,NULL);
	  if(cmd>-1)Conf_val[cmd]=true;
	  }
	free(pth); free(plst);
	}
    free(ptr);
  }

  if(argc>1)goto skpcomlst; 

  if((ptr=sysIdRead(*workspace, 4))!=NULL){/* autoexec */
    char *pm[2];
    fmtVal(ptr); /* rem "" sybm for UseFile */
    *pm=ptr;	pm[1]=NULL;
    lib=RTLscript(NULL,pm,false);
    free(ptr);
	}

  while(CommNumb!=11520){
#ifdef _STDIO_H
    static char fmt0[]="\n%s]";
#else
    static char fmt0[]="\n%s>";
    cursorXY(&i, NULL);
#endif
    if(CommNumb==ALT_Q)return 1;
    if(lib/*&&lib->fpt*/){
      pth=(char *)ReGetDir(lib->CurDir,NULL,1);
#ifdef	_STDIO_H
      printf( fmt0, pth? pth:rootchs);
#else
      printf( fmt0+(i>1? 0:1), pth? pth:rootchs);
/*      i=pth ? strlen(pth)+1 : 2;*/
#endif
      if(pth)free(pth);
    }
#ifdef	_STDIO_H
    n=InCon(buffer,479);
#else
    *buffer=0;
    n=InpText(buffer, ComMsg, lib? lib->comlst : libmanu->comlst);
    switch(n){
    case ALT_Q : 
    case ALT_X : CommNumb=n;
    case ESC : continue;
	}
    for(i=0;i<FastKey;i++)
	if(n==ComMsg[i+4/*FASTKEYPOS]*/])scopy(buffer,FastCmd[i]);
#endif


    skpcomlst: /* Init */ shwMsg=0; FreeWMsg=0; modemsg=0;
     kUndel=0; kUndd=0; OverW=0;/* clear every */
     lib=Comjxor(lib,buffer); /* set CommNumb */
  }
ex: for(i=LASTSPACE;i>-1;i--)if(workspace[i])RTLdestroy(workspace[i]);
 }
 else { errMsg: 
PrnTxt(1,-1,56,
#ifndef	_STDIO_H
1
#else
34
#endif
,libCode);
	printf(nOpen,rundat[n]);
 }
return 0;
}
