/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Copyright Linjianghua
	Reserve all rights of the file
*/

#include "filecon.h"

const char curSpace[]="\nCreate workspace : %d\n";
char shwMsg;

void GetDfltDir(RunTimLib *lib)
{
   if(lib->DefaultDir>40)
	lib->CurDir=DirRead(lib,DIRalloc(),NULL,lib->DefaultDir);/* default dir */

}

bool putspace(RunTimLib *lib,int msg)
{
int i;
for(i=msg&16384 ? 0:1/* use for makertl, no running-infodata */; i<SPACELIMIT&&workspace[i];i++);
if(i<SPACELIMIT){
  workspace[i]=lib;
  lib->fd=i;
  return true;
  }
else DefaultManu(46);
return false;
}

char *sysIdRead(RunTimLib *lib, _Long numb)
{
MAU send;
NumbRead(lib, NULL, numb, &send, 1, NUMB_SYS_ID|FREE_READ);
return send.buf;
}

RunTimLib *RTLinstance(const char *fnm, int msg)
{/* 0bit ReadScript, 1bit show open-err 
   2bit info, 3bit open first dir in root as curdir */
  RunTimLib *lib=RTLopen(fnm);
  if(lib){
      if(putspace(lib,msg)==false){
	RTLclose(lib,NULL); return NULL;
	}
#ifdef  _STDIO_H
      lib->fname=realpath(curprgnam, NULL);
#else
      lib->fname=fullname(curprgnam);
#endif
      free((void *)curprgnam);
      if((msg&8)&&lib->pCSB_dir>0)/* first dir address */
	  dkread(lib,lib->pCSB_dir+DIRE_ADDR,&lib->DefaultDir,4,1);

      GetDfltDir(lib);
      if(msg&1){/* read script */
	char *pt=sysIdRead(lib,1);
	if(pt)puts(pt);
	}
      if((msg&4)&&idxdscpt==ErrScnFile)reportBug();
    }
  else if(msg&2){
	char *pt=NULL;
	int nmb=idxdscpt;
	if(nmb==1){
	char *dat;
	int i=CMDNMB+3+1;
	while((dat=GetManu(i))!=NULL){
	 pt=memstr(verbuf,29,dat,0,2); free(dat);
	 if(pt){ ManuInfo(i+1,1); break; }
	 i+=2;
	}
	}
	if(pt==NULL){
	   if((msg&16)==0)ManuInfo(nmb,true);
	   else idxdscpt=nmb; /* reset old-value, NumbScan change idxdscpt */
	   }
	}
  return lib;
}

const char *pExeNam[3]={".rtl", RLS, NULL };
int ChkLibUse(const char *fnam)
{
int i;
const char *ptr=IsExec(fnam,pExeNam);
if(ptr){
#ifdef	_STDIO_H
  char *pth=realpath(ptr,NULL);
#else
  char *pth=fullname(ptr);
#endif
  free((void *)ptr);
  for(i=0; i<SPACELIMIT && (workspace[i]==NULL ||
#ifdef	_STDIO_H
strcasecmp(pth,workspace[i]->fname)
#else
	strcmp(pth,workspace[i]->fname)
#endif
); i++);
  free(pth);
if( i<SPACELIMIT )return i;
}
return -1;
}

RunTimLib *RTLspace(RunTimLib *lib0,char *pth,int msg)
{
RunTimLib *lib1;
const char *pt=NULL;
int i=ChkLibUse(pth);
if(i<0){
  lib1=RTLinstance(pth,msg/* 1+2+4 */);
  if(lib1)
      if(CommNumb!=-343)RTLdestroy(lib0);
      else pt=curSpace;
}
else if(i>0){
	if(workspace[i]==lib0){ puts("Current space"); return lib0; }
	pt="\npop %d as current space";
	lib1=workspace[i];
	}
       else {
	ManuInfo(50/* self-rtl */,true); return lib0;
	}

if(lib1&&((msg&4)&&diguei==0||shwMsg)){ RTLinform(lib1,InpBuf); puts(InpBuf); }
if(pt){
#ifndef	_STDIO_H
	cursorXY(&i, NULL);
	if(i<1)pt++;
#endif
	printf(pt,lib1->fd);
}
return lib1;
}

void RTLdestroy(RunTimLib *lib)
{
if(lib){
  workspace[lib->fd]=NULL;
/*  ReGetDir(lib,lib->CurDir,NULL, 8 );*/
  lib->DefaultDir=lib->CurDir? lib->CurDir->pOwn:39;
  RTLclose(lib,Compress);
  }
}
