/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010
  Copyright Linjianghua(Xempo)
  reserve all rights
 */

#include <time.h>
#include "infor.h"
#include "script.h"
#include "jxswitch.h"
#include "rtlcom.h"
#ifndef _STDIO_H
#include <bios.h>
#endif

#define X_BTN 512 /* also in readfile.c */

char runLog[]="\\Log";
bool errSig_space;
_Long Err_Numb;

void RunLog(char *chs)
{
Err_Numb=WriteLimit(*workspace,runLog,chs,Err_Numb,8, 0);
}

_Int idxUsage(_Int nCom, const _Int *coms)
{  
int i;
for(i=0; coms[i]; i++)if(nCom==coms[i])return i;
return -1;
}

char *GetInform(int idx,bool root)
{
if(*workspace){
  MAU send;
  NumbRead(*workspace,root? NULL:workspace[0]->CurDir,idx,&send,1, FREE_READ);
  if(root==false)errSig_space=true; /* for mult workspace show */
  return send.buf;
}
return NULL;
}

void UsageMsg(int nCom)
{
char *pt=GetUsage(idxUsage(nCom,kval));
if(pt){
	puts(pt);	free(pt);
	}
}

void scriptTips(int msg)
{
if(diguei && modemsg /* 0: only string, not file */ ){
#ifndef	_STDIO_H
   int x, y;
#endif

   char buf[320];
   sprintf(buf," >> %s %d: ",scpfname,scpline);

#ifdef	_STDIO_H
   printf("\033[33;1m%s\033[0m",buf);
   printf(msg? "%s\r\n%s\r\n":"%s\r\n",scpbuf,msg? quitScp:SPC);
#else
   cursorXY(&x, &y);
   PrnTxt(x, y, strlen(buf), 14, buf);
   printf(msg? "\n%s\r\n%s\r\n":"\n%s\r\n",scpbuf,msg? quitScp:SPC);
#endif

   strcat(buf,scpbuf);
   RunLog(buf);

#ifdef	_STDIO_H
   if(msg>1)switch(InCon(buf,4)){
	case 27 : CommNumb=-331; break;
	case 'e' :  CommNumb=-330;
	}
#else
   if(msg>1&&_bios_keybrd(0)==283)CommNumb=-331;
#endif

   *buf=0;/* clear incon-buf */
	}
}

int ManuInfo(int idx,int msg)
{
char *pt=GetManu(idx);
int y, x;
if(msg&2){
	if(pt){
		x=popMsg(pt,NULL,msg&1? 0:1);
		free(pt);
		return x;
	}
	else {
		rtlout=stdout;
		goto once_again;
	}
}
if(rtlout==NULL)rtlout=stdout;
if(rtlout==stdout){
  if(msg){
#ifndef		_STDIO_H
	cursorXY(&x, &y);	x+=2;
	PrnTxt(x,y,3,4,"** ");
	gotoXY(4+x,y);
#else
	PrnTxt(2,-1,3,31,"** ");
#endif
  }
}
else fprintf(rtlout,"    ");

once_again: 
if(pt){ fprintf(rtlout,"%s%c\n",pt,ErrorPara);  
	if(Conf_val[1])RunLog(pt);
	free(pt);
	}
else {
	fprintf(rtlout,"No about message: %d\n",idx);
	if(msg&2)return -1;
	}

if(out_scrn_same){ out_scrn_same=false; goto once_again; }

if(rtlout!=stdout)fprintf(rtlout,"\n\n");
scriptTips(2);

return 0;
}

void DefaultManu(int idx)
{
ManuInfo(idxdscpt<0x7ffe? idxdscpt:idx,1);
}

void RTLinform(RunTimLib *lib, char *buf)
{
if(lib/*&&lib->fpt*/){
  DIRE *cdir=lib->CurDir;
  int len;
  char *libNam=rstrrchr(lib->fname,ROOT_CH,ROOT_CH);
  len=sprintf(buf,"[%s %s]  Fnumb:%ld  Fdir:%ld  ",libNam,lib->fsfmt,
	lib->tolNumb,lib->tolDir);
  len+=sprintf(buf+len,"Size:%ld/%ld\n",lib->usesize,lib->fsz);
  CDirInfo(lib,cdir,buf+len);
}
else {
   char *dat=GetManu(2);
   if(dat){ scopy(buf,dat); free(dat); }
 }
}

int putmsg(const char *txt, const char *cap, int fg)
{
static const _Int keys[6]={ 27, 'n', 'y', 'a', 's' };
char Key=1, code;
if(cap)puts(cap);
if(txt){
	printf(txt);
	fflush(stdout);
	}
if(fg && 0==(fg&X_BTN)){
  while(isdone(Key,keys)==false){
#ifdef	_STDIO_H
	char bu[8];
	code=InCon( bu, 7 );
#else
	code=_bios_keybrd(0)&0xff;
#endif
	Key=code!=27? code|32:27;
	}
  printf("%c\n",code);
}
return Key;
}
