/*
  Designed by LinJiangHua(Xempo) 2004-2006
  Copyright Linjianghua(Xempo).
  All Rights Reserve.
*/

#ifndef	_STDIO_H
#include <io.h>
#endif

#include "c_lib.h"
#include "normlib.h"
#include "infor.h"

void scopy(char *d, const char *s)
{  while( (*d++=*s++) ); }

const char *separChr(const char *pt)
{
const char *ptr=NULL;
while(*pt){
	if(*pt=='\\'||*pt=='/')ptr=pt;
	pt++;
	}
return ptr;
}

bool IsAbsPath(const char *fname)
{
char chr=*fname;
return chr=='\\' ||chr=='/'|| (fname[1]==':'&&(fname[2]=='\\'||fname[2]=='/'))&&(chr|32)>96&&(chr|32)<123;
}

#ifndef  _STDIO_H
char *fullname(const char *fname)
{/* can free every time */
char buf[320];
getcwd(buf, 319);
if(IsAbsPath(fname)){
#ifndef  _STDIO_H
	if(*fname=='\\'||*fname=='/'){
		scopy(buf+2,fname); fname=buf;
		}
#endif
	return strdup(fname);
	}
else return catstr(buf,fname,ROOT_CH);
}
#endif

unsigned int Delete(char *pt,unsigned int cn)
{
unsigned int len=strlen(pt);
if(cn>=len){ *pt=0; return len; }
memmove(pt,pt+cn,len+1);
return cn;
}

void Insert(char *sc, const char *in)
{
size_t  ln=strlen(sc), len=strlen(in);
if(ln)memmove(sc+len, sc, ln);
memcpy(sc,in,len);
sc[ln+len]=0;
}

int extParaLen(const char *pt)
{
char ch;
int n;
for(n=0;(ch=pt[n])!='\\'&& ch!='/' && (ch|32)!=32 && ch!=9; n++);
return n;
}

int GetComm(char *buf, const char *comchs, const _Int *kval, char **extpara)
{
int rt=-399;
if(*buf){
  unsigned int n, k;
  char tmp[80], ch;
  const char *pt;
  static const char memblk[5]={ 13,10,',' , ';' };
  rt=-400;
  while(*buf==32||*buf==9)buf++;
  for(n=0; n<79&&(ch=buf[n])!='.' && (ch|32)!=32 && ch!=9 &&
	!(extpara && (ch=='\\' || ch=='/')); n++)tmp[n]=ch;
  pt=comchs;

 rechk: pt=memstr(pt,0,tmp,n,1);
  if(pt){
      if( memchr(memblk,pt[n], 5) &&
         (pt==comchs||strchr(memblk,pt[-1])) ){
         k=0;
         while(pt>comchs)if( strchr(memblk,*(--pt)) )k++;
         rt=kval[k];
      }
      else { pt+=n; goto rechk; }
  }
  if(extpara){
    if( ch=='.' ){
	if(extParaLen(buf+n+1))*extpara=buf+n+1;
	}
    else *extpara=NULL;
  }
}
return rt;
}
