/*
  Write & edit by Linjianghua 2004-2006
  Copyright Linjianghua
  Reserve all rights of this file
*/

#ifndef	_STDIO_H
#include <io.h>
#endif

char verbuf[30]; /* other use for check lib-tag */
RunTimLib *RTLopen(const char *filenam)
{
if(filenam){
 char *descpt=verbuf;
 const char *oldfnm=filenam;
 RunTimLib *lib;
 FILE *pff;
 idxdscpt=0x7fff;
 ropen: pff=PathOpen(filenam,"rb+");
   if(pff==NULL){
     if(idxdscpt>0x7ffd)idxdscpt=0;
     Re_Open: if(oldfnm==filenam&&memstr(oldfnm,0,ExtRTL,5,0)==NULL){
	    filenam=catstr(oldfnm,ExtRTL,0);
	    goto ropen;
	}
	if(filenam!=oldfnm)free((void *)filenam);
	return NULL;
   }
   else {
     if(fread(descpt,sybchrlen,1,pff)<1 ||
	memcmp(descpt,FileFmt,libtaglen)){
/*	if(idxdscpt>0x7ffd) */ idxdscpt=1;
	skpexit: fclose(pff);	free((void *)curprgnam);
	if(idxdscpt==12)return NULL; /* fail to alloc mem */
	goto Re_Open;
     }
   }
   lib=RTLalloc();/* mem alloc */
/*   if(lib==NULL)goto skpexit;*/
   lib->fpt=pff;
   memcpy(lib->fsfmt,descpt+libtaglen, FS_FMT-1);

   if(fread(&lib->selfdir,ctrlsize,1,pff)<1){ idxdscpt=3; goto skpexit; }
   lib->n_statLen=GetLenght(getshadow(lib));
#ifdef	_STDIO_H
struct stat st;
fstat(pff->_fileno, &st);
lib->fsz=st.st_size;
#else
   lib->fsz=filelength(fileno(pff));
   lib->comlst=(ComLst *)zalloc(sizeof(ComLst));
#endif

   if(oldfnm!=filenam)free((void *)filenam);
   idxdscpt=0x7fff;/* clear it for scriptfile */
   return lib;
 }
 else return NULL;
}

int RTLclose(RunTimLib *lib,RunTimLib* (*Compr)(RunTimLib *,const char *,const char *,int))
{/* return compress msg */
int rt=0;
if(lib){
/*  if(lib->fpt){*/
  _Long sz;
    if(lib->mdf){
      sz=lib->fsz-lib->usesize;
      if(sz>lib->CmprSiz*1024 && sz*100/lib->fsz>lib->CmprPer&&(lib->mdf&10/* 2|8 */)==0){
	if(Compr)lib=Compr(lib,NULL,SPC,288 /* >32:reopen & 256 show ... */ );
	else rt=1; /* for extern(OS)-call */
	}
      dkwrite(lib,sybchrlen,&lib->selfdir,ctrlsize);
    }
    DirClose(lib,lib->CurDir);
    if(lib->fname)free(lib->fname);
    fclose(lib->fpt);
#ifndef	_STDIO_H
    free(lib->comlst);
#endif
    free(lib);
  }
return rt;
}
