/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Copyright Linjianghua
	Reserve all rights of this file
*/

#include "stat_dm.h"

_Int kUndel, kUndd;

void dStatProc(RunTimLib *lib,char **pm, int nCom)
{
  char *dname;
  DIRE *dir=DirFixNam(lib,lib->CurDir,*pm,&dname);
  if(idxdscpt>0x7ffd){
    if(dir==lib->CurDir||dir==NULL){
	switch(nCom){
	case N_DELS :
	case DIRE_EMPTY : dname=(char *)DirOpen(lib,dir,dname);/* cvt to send */
	case 8005 :
	case 8012 : if(d_remove(lib,dir,dname,nCom)==false)reportBug();
		break;
	case 8106 : /* ren */
	case 8108 : if(d_rename(lib,dir,dname,pm[1])==false)reportBug();
	}
    }
    else ManuInfo(10,true);
  if(dir!=lib->CurDir)DirClose(lib,dir);
  }
  else reportBug();
}

void nStatProc(RunTimLib *lib,char **pm, int nCom)
{
  _Long numb;
  DIRE *dir=DirOpen(lib,lib->CurDir,PathFixNumb(*pm,&numb));
  if(idxdscpt>0x7ffd){
    if(dir==lib->CurDir||dir==NULL){
	switch(nCom){
	case 8106 : 
	case 8105 : nCom=n_rename(lib,dir,numb,atol(pm[1])); break;
	default : nCom=n_remove(lib,dir,numb); /* 8005, 8006 */
	}
	if(nCom==false)reportBug();
    }
    else ManuInfo(10,true);
    if(dir!=lib->CurDir)DirClose(lib,dir);
  }
  else reportBug();
}

void DirUnDelete(RunTimLib *lib,char *pm, int nCom)
{
  DIRE *dir=DirOpen(lib,lib->CurDir,pm);
  if(idxdscpt>0x7ffd){
    DirStat *du1;
     if((du1=DirSeek(lib,dir,(char *)SPC,nCom/* DIRE_RESCUE:DIRE_UNDEL*/))!=NULL){
      DirStat *du;
      _Long pos=lib->statpos;
      if((du=DirSeek(lib,dir,du1->name,DIRE_DEL))!=NULL&&kUndd!='a'){
	char buf[102], *dscpt=GetManu(27);
	free(du);	sprintf(buf,dscpt,du1->name);
	free(dscpt);	kUndd=popMsg(buf,NULL,1);
	if(kUndd=='n'||kUndd==59||d_remove(lib,dir,du1->name,0)==false)goto skp;
      }
      lib->statpos=pos;
      DirStatChange(lib,dir,du1,1,1,0);
      skp: free(du1);
    }
    else DefaultManu(I_ResucDir);
    if(dir!=lib->CurDir)DirClose(lib,dir);
  }
  else reportBug();
}

int NumbUnDelete(RunTimLib *lib,char *dirnam, int nCom)
{
  DIRE *dir=DirOpen(lib,lib->CurDir,dirnam);
  int rt=0;
  if(idxdscpt>0x7ffd){
    int msg;
    BYTE *unit;
    DirShadow *pdp=GetDirShadow(dir,lib);
    switch(nCom){
    case -304 : 
    case -298 : msg=NUMB_RESCUE;
		break;
    default : msg=nCom;
    }
    if((unit=StatSeek(lib,dir,0,NULL,msg))!=NULL){
      BYTE *stat;
      _Long pos=lib->statpos;
      if(isZero(pdp->Format)==false){
      	_Long nmb=fixstatnumb(pdp,unit);
      	if((stat=StatSeek(lib,dir,nmb,NULL,NUMB_DEL))!=NULL&&kUndel!='a'){
	   char buf[102], *dscpt=GetManu(26);
	   free(stat);	   sprintf(buf,dscpt,dir->name,nmb);
	   free(dscpt);	   kUndel=popMsg(buf,NULL,1);
	   if(kUndel=='n'||kUndel==59)goto skp;
	   n_SetDel(lib,dir,unit,lib->statpos);
	}
      }
      *unit=1;	rt=1;
      ChgStat(lib,dir,unit,pos,1,1);
      skp: free(unit);
    }
    else if(nCom<-300)DefaultManu(I_NoResuce); /* msg==-304 */
    if(dir!=lib->CurDir)DirClose(lib,dir);
  }
  else reportBug();
return rt;
}
