/*
	Write & edit by Linjianghua 2004-2006, 2008-2011
	Copyright Linjianghua(Xempo)
	Reserve all rights this file
*/
#include "dire.h"
#include "script.h"
#include "infor.h"
#include "_tfd.h"

extern TxtDat tfd;

const _Int inpkmsg[8]={ F1, ENTER, ESC, ALT_Q,
/* mkbreakkey */ALT_X, CTRL_Q, CTRL_E, 0 /* force end to write */ },
chrlen[IntType_Count]={4,3,4, 4,4,5, 4,5,5};
_Int	CommNumb;
char FreeWMsg;
const char TypeStr[13][6]={"char","int","long","BYTE","WORD","DWORD",
	"Hex8", "Hex16", "Hex32", "None", "Separ", "_Void", "Txt" };
static const char finclude[]="#include:";

#define incl_Len	sizeof(finclude)-1
char *isFile(MAU *pdat, char *fn, int type)
{
char *pf;
int len;
if(fn==NULL)return NULL;
if(type!=_file){
	if(memcmp(fn,finclude,incl_Len))return NULL;
	pf=fn+incl_Len;
	}
else pf=fn;
while(*pf==32||*pf==9)pf++;
len=strlen(pf)-1;
while(strchr(divsyb,pf[len]))len--;
pf[len+1]=0;
pdat->buf=ReadFile(pf,(unsigned int *)&pdat->len,type!=_void/* as *.png must be bin */);
return pdat->buf;
}

char memSepara[2];

int putMAU(MAU *pdat,char *buf,int type)
{/* fixSPC=false only in Input-Kuang */
if(buf){
  char *pt=NULL, *adjust;
adjust_Ld: if((adjust=isFile(pdat,buf,type))==NULL){
		if(pt==NULL)pt=buf;
		if(type==_file)type=_sold;/* para: .f to fail to load file that must process */
		}
	else {
		if(pt)free(pt);
		pt=adjust;	buf=pt;
		if(type==_file)type=_txt;
		goto adjust_Ld;
	}
  if(pt && *pt){
  int j;
  _Int i;
  char *prt;
    if(pdat->buf!=pt){/* in script, numbset will have -l:??? , so use thire len */
	pdat->buf=pt;
	pdat->len=strlen(pt);
    }
    for(j=0;j<IntType_Count;j++){/* _Int-type */
      prt=strstr(pt,TypeStr[j]);
      if(prt==pt&&prt[chrlen[j]]==':'){
	prt+=chrlen[j]+1;
	if(type<IntType_Count)printf(" !! Use \"%s=\" keyword, ignore para \'%c\'\n",TypeStr[j],TypeChr[type]);
	type=j;
   _IntType:while(*prt==32||*prt==9)prt++;
	pdat->buf=(char *)atoi_lst(prt,&i,type/* t */);/* script can't free(pt) */
	pdat->len=i*intType[type];
	goto _exit_;
	  }
	}/* _Int-type */
  switch(type){
  case _sold : 	/* only use to con, no in script or #include: */
	for(buf=pt;strchr(divsyb,*buf);buf++);
	if(buf>pt){
		pdat->len-=buf-pt;
		memmove(pt,buf,pdat->len);
		}
	for(buf=pt+pdat->len-1;strchr(divsyb,*buf)&&buf>pt; buf--)pdat->len--;
  case _txt : type=_void;
	pdat->len=FmtText(pt,pdat->len);/* 7&8, txt for disk, use for number in script */
	break;
  case _void : pdat->buf=pt;
		pdat->len=strlen(pt);
	break;
  case _separa : /*pdat->len=*/FmtInput(buf, NULL, memSepara, 0);
	break;
  default : if(type<IntType_Count){ prt=pt;  goto _IntType; }
  }
_exit_:  if(pt!=buf&&IsIntType(type))free(pt);
 }
}
return type==_file? _void:type;/* _file is not save type, and file would be bin, such *png  */
}

bool NumbPut(RunTimLib *lib,DIRE *dir,_Long nmb,
       MAU *pdat,int n, int msg)
{
  BYTE *stat=WriteInit(lib,dir,nmb,pdat,n, msg);
  if(stat){
    if(idxdscpt<0x7ffd){
      char infobuff[200], *msgtxt, *pth;
      switch(OverW){
      case 's' :
      case 27  : _fail:	free(stat);
		return false;
      case 'a' : break;
      default : 
	msgtxt=GetManu(idxdscpt); /* this must first read, idxdscpt can change */
	pth=(char *)ReGetDir(dir,lib->CurDir,1);
	scriptTips(0);
	sprintf(infobuff,msgtxt? msgtxt:"Over %s\\%ld",pth? pth:SPC,nmb);
	OverW=popMsg(infobuff,NULL,1);
	if(pth)free(pth);
	if(msgtxt)free(msgtxt);
	if(OverW=='n'||OverW==27||OverW=='s')goto _fail;
      }
	idxdscpt=0x7fff; /* mainly for script, would tog other Info, so clear it */
    }
    WriteStat(lib,dir,stat,pdat,n);
    return true;
  }
  else reportBug();
 return false;
}

_Long WriteLimit(RunTimLib *lib,char *dirnam,char *dat,_Long nmb,_Int cnlmt, int msg)
{
DIRE *dir=DirOpen(lib,NULL,dirnam);
if(dir){
BYTE *stat, *unit, i, cnt;
MAU snd;
snd.buf=dat;	snd.len=0;
if(nmb==0){
  StatSeek(lib,dir,0,NULL,NUMB_LAST|msg );
  nmb=dir->_numb_;
}
if(nmb>=dir->num_stats_block*cnlmt){
  _Long adr, padr, pos;
  _Int len=dir->num_stats_block*dir->n_statLen+4;
  stat=(BYTE *)malloc(dir->num_stats_block*dir->n_statLen+4);
  unit=stat;
  nmb-=dir->num_stats_block;
  adr=dir->CSB_numb;
  dkread(lib,adr,unit,len,1);
  for(cnt=0,i=0;i<dir->num_stats_block;i++,stat+=dir->n_statLen)
	if(*stat==1){ *stat=2; cnt++;  ChgStat(lib,dir,stat,adr+i*dir->n_statLen,-1,8); }
  padr=*(_Long *)stat;
  while( padr>0 ){
	pos=padr+len-4;
	dkread(lib,pos,&padr,4,1);
  }
  dkwrite(lib,pos,&adr,4);
  dir->CSB_numb=*(_Long *)stat;
  *(_Long *)stat=0;
  dkwrite(lib,adr+len-4,stat,4);
#ifndef _NONE_FAST_PAGE_
  memset(lib->zdpbuf,0,sizeof(zdivPage)*PgBufDivLen);
  for(i=0;i<PgBufDivLen;i++)
    if(lib->zdpbuf[i].pDIRE==dir->pOwn){
	if(lib->zdpbuf[i].pCSB==adr)lib->zdpbuf[i].pDIRE=0;
	lib->zdpbuf[i]._numb_-=cnt;
	}
#endif
  free(unit);
}
NumbWrite(lib,dir,nmb++,&snd,1, msg);
if(dir!=lib->CurDir)DirClose(lib,dir);
}
return nmb;
}

void NumbIns(RunTimLib *lib,char **pms,char *extpara,int msg)
{
  _Long nmb;
  un_Int style;
  int n, j, b;
  MAU *mau;
  char **pmlst;
  BYTE *idx, Init=_sold;/* normal-console is text-mode */
  DIRE *dir=lib->CurDir;
  if(msg==1800){/* It's not clear what append specify dir */
	j=0;
	append: StatSeek(lib,dir,0/* must 0 for count */,NULL,NUMB_LAST);
	nmb=dir? dir->_numb_:lib->_numb_;
	idxdscpt=0x7fff;	/* perhan idxdscpt==I_NoNumb no csb*/
	}
  else {
	char *nam=PathFixNumb(*pms,&nmb);
	if(numNone){ ManuInfo(42,1);	return; }
	j=1;
	dir=DirOpen(lib,dir,nam);
	if(idxdscpt<0x7ffd){ reportBug(); return; }
	if(msg==1004/* add */)goto append;
	}
  if(dir){  style=dir->Format; n=dir->_DAU; }
  else {  style=lib->Format; n=lib->_DAU; }
  if((msg==1800||msg==1004)&&!isZero(style)){
	ManuInfo(I_NotZero,true); goto ex;
	}
  b=n;
  if(pms[j])pmlst=SetArgv(pms[j],&n," \t");
  else goto _jmp_;
  if(pmlst[0]==NULL){
	_Int key;
#ifndef	_STDIO_H
	ComLst *cmlst=lib&&lib->comlst? lib->comlst:libmanu->comlst;
#endif
	free(pmlst);
_jmp_:	pmlst=(char **)zalloc((b+1)*sizeof(char *));
	Init=_void; n=-1;
	while(++n<b){
		printf("Data:");
		*InpBuf=0;
#ifdef	_STDIO_H
		key=InCon(InpBuf,400);
#else
		key=InpText(InpBuf,inpkmsg+1,cmlst);
#endif
		switch(key){
		case F1 :   UsageMsg(1000); break;
		case CTRL_E :
		case ALT_Q :  
		case ALT_X : 
		case ESC : CommNumb=key; goto _ex_;
		default : pmlst[n]=strdup(InpBuf);
		}
		}
	}

    idx=(BYTE *)malloc(n*2);
    mau=MAUalloc(n);
    ComExtParas(extpara,idx,n,Init);
    for(b=0; b<n; b++)
	if((j=idx[b])!=_none){
		if(j==_separa)*memSepara=idx[b+n];
		(void)putMAU(mau+b,pmlst[b], j);
		}
/*	else memset(mau+b,0,sizeof(MAU));*/
    NumbPut(lib,dir,nmb,mau,n,0);
    for(j=0; j<n; j++)
	if(mau[j].buf&&mau[j].buf!=pmlst[j])free(mau[j].buf);
      free(idx);      free(mau);
_ex_: free(pmlst);
    ex:if(dir!=lib->CurDir)DirClose(lib,dir);
}

void TxtImpor(RunTimLib *lib1,char *dirnam, int nCmd)
{
_Long nmb;
MAU send[2];
_Int n, i;
DIRE *dir=DirOpen(lib1,lib1->CurDir,dirnam);
if(idxdscpt>0x7ffd){
	if(nCmd!=1003&&nCmd!=-305)n=1;
	else {
	StatSeek(lib1,dir,0,NULL,NUMB_LAST);
	nmb=dir? dir->_numb_:lib1->_numb_;
	/*if(idxdscpt!=I_NoCSB)
	else nmb=0;*/
	n=2;
	}
	for(OverW=0,i=0;i<tfd.toluse&&OverW!=283;i++){
	    memset(send,0,sizeof(send));
	    if(nCmd!=1003&&nCmd!=-305){
		nmb=atol(tfd.org[i]);
		putMAU(send,tfd.nw[i],_sold);
		}
	    else {	/* add	*/
		putMAU(send,tfd.org[i],_sold);
		putMAU(send+1,tfd.nw[i],_sold);
		}
	NumbPut(lib1,dir,nmb++,send,n,0);
	}
	if(dir!=lib1->CurDir)DirClose(lib1,dir); 
	}
else DefaultManu(idxdscpt);
}
