/*
	Designed & modify by Xempo(Linjianghua)
	Copyright 2004-2005 Xempo
	Reserve all rights of this file
	email : xempo@189.cn
*/

#ifndef _C_LIB_DEF_
#define _C_LIB_DEF_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dos.def"

#define Question	4096
#define WrapLine	8192
#define	_Quest_		12288
#define	YNE		1
#define	YNEA		2

#define INTS_CNT 9

extern const BYTE intType[INTS_CNT];

extern const char CvtFmt[INTS_CNT][5];

extern const char prog[], memblkcmp[], nocreat[],
	nOpen[], ErrAlloc[], TfdMsg[], sizlst[],
	disChs[], remChs[], remDf[];

extern const char *schlibconf[], *schtfdconf[],searchfield[];

extern int cnt_path;
extern const char *curprgnam, **progpath;

extern int KShowMsg(const char *fnm,const char *fmt,int msg);

extern bool isdone(_Int k,const _Int *msg);

extern int (*popMsg)(const char *txt, const char *cap, int msg);

extern char **SetArgv(char *src,int *n,const char *fmt);

extern unsigned int RemTok(char *input);

extern void *atoi_lst(char *pth, _Int *tol, _Int type);

extern const char SPC[];

extern bool IsAbsPath(const char *fname);

/*remove space for val, return val len, if you want use space, please use ""
example: "   Warn: " */
extern int fmtVal(char *val);

extern unsigned int Delete(char *pt,unsigned int cn);

extern void fmtstr(char *pChs, const char *df,char c);

/*  flg:
0 bit: setbit is first string; else  is last string
1 bit: setbit is use case; else is no case */
extern char *memstr(const char *src,unsigned int ln,
	const char *in,unsigned int ln2,int flg);
/* true  src==in */
extern int msg_memstr;

#define strstrcs(sc,in) memstr(sc,0,in,0,1)

extern char *strchrs(const char *src,const char *chars);

extern char *catstr(const char *src, const char *append, char c);

extern char *rstrrchr(char *pth,char fnd,char rep);

extern bool IsRemChs(char *chs,bool *IsRemMsg,char endchr);

extern bool GetConf(char *txt,const char *segnam,long *Val,const char *pmfmt,int msg);

extern int ParamsCvt(char **pm, long *retval, char (*retsyb)[4], const char *fmtchs,
	int *fmtsval, int msg);

extern unsigned int FmtInput(char *Inp,int *ret,const char *fmt,char ch);

extern FILE *PathOpen(const char *fnm, const char *fmode);

extern char **MemDiv(char *src,const char *fmt,int lmt);

extern char **envpath(const char *prgpath, const char *defpath);

extern const char NoDscpt[];

/* return (dscpt)pts, n is pts cn,
if fail, all pts=>NoDscpt */
extern const char **GetDscpt(const char *fnm,int n);

extern unsigned int FmtText(char *buf,unsigned int len);

extern char *ReadFile(const char *fname,unsigned int *flen,bool txtmsg);

extern const char *IsExec(const char *fname,const char **pExt);

extern long strcvtdate(char *txt);

extern unsigned int strcvttime(char *txt);

extern BYTE *strcvtdttm(const char *txt);

#endif

