/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2011
  Copyright Linjianghua(Xempo)
  reserve all rights of this file
*/
#include "dire.h"
#include "export.h"
#include "jxswitch.h"
#include "_tfd.h"
#include "rtlcom.h"

#include "numbio.h"
#ifndef	_STDIO_H
#include <io.h>
#include <direct.h>
#endif

#include "normlib.c"

#define FileNamCmp stricmp

FILE *dirfp;
static const char  *MainDir;
const char **dscpts; /*, Fmt[]="  //\t%s\r\n";*/

int ExpNumbs(RunTimLib *lib,DIRE *dir,BYTE *dsb)
{
  BYTE i, *unit;
  DirShadow *pdp=GetDirShadow(dir,lib);
  _Int num_stats_block=pdp->num_stats_block,
	unitlen=pdp->n_statLen;/* care flow bit */
  _Long nmb;
  char buf1[56];
  _Int n=pdp->_DAU;
  int j, b, len;
  MAU *send=MAUalloc(n);
  for(unit=dsb,i=0;i<num_stats_block;i++,unit+=unitlen){
    	nmb=fixstatnumb(pdp, unit); 
    if(*unit==1 ){
      for(b=0,j=0;j<n;j++)
	if(ReadDAU(lib,dir,unit,send+j,j))b=j+1;
	else send[j].len=0;

      len=sprintf(buf1,"-u:%d -l:",b);
      for(j=0;j<b;j++)
	 len+=sprintf(buf1+len,"%u,",send[j].len);
/*    len=strlen(buf1);	*/
      if(len>0)buf1[len-1]=0;
      fprintf(dirfp,dscpts[5],nmb,buf1);
      for(j=0;j<b;j++){
	fwrite("{\r\n",3,1,dirfp);
	if(send[j].buf){
		OutCvt(send+j, _void);
		fwrite(send[j].buf,send[j].len,1,dirfp);
		free(send[j].buf);
	}
	fwrite("\r\n}\r\n",5,1,dirfp);
      }
    }
  }
  free(send); /* send->buf have free in fwritMAU */
  return 1;
}

int ExpDirs(RunTimLib *lib,DIRE *pcdir,DIRE *dir)
{
  DirShadow *pdp=GetDirShadow(dir,lib);
  const char *style, zmode[]="-Z";
  int i;
  if(dirfp&&dirfp!=mainfp)fclose(dirfp);
  style=isZero(pdp->Format) ? zmode : SPC;
  if(dir){
    char  *pm=(char *)ReGetDir(dir,NULL,1),
	*pt=catstr(MainDir,pm,0);
    if(access(pt,0)==0||mkdir(pt
#ifdef	_STDIO_H
,0770
#endif
)==0){
      time_t t1;
      char *ptr, *rtlfile=catstr(pt, "runtime.rls", ROOT_CH);
      dirfp=fopen(rtlfile,"wb");
      fwrite(dscpts[1],strlen(dscpts[1]),1,dirfp);
      fprintf(mainfp,dscpts[4],pm,style,
      pdp->_DAU,dir->dir_stats_block,dir->num_stats_block);
      time(&t1);
      fprintf(mainfp,"  //\t%s",ctime(&t1));
      for(i=0; rtlfile[i]; i++)
	if(rtlfile[i]=='\\')rtlfile[i]='/';
      fprintf(mainfp,dscpts[6], pm, strchr(rtlfile, '/')+1);
      free(rtlfile);
    }
    else ManuInfo(47,true);
    free(pm); free(pt);
  }
  else {
	fprintf(mainfp,dscpts[3],lib->fname,style,pdp->_DAU,lib->dir_stats_block,lib->num_stats_block);
	dirfp=mainfp;
	}
  return 1;
}

static const char fmt[2]={1};
void Export(RunTimLib *send,int n,char **pm)
{
int msg;
DIRE *dir=JxDirPara(send,n,pm,NULL,&msg,8020);
if(idxdscpt>0x7ffd){
  char *pt, *expdec, *os_dir=pm[1], *_fnam;
  if(os_dir==NULL)goto os_cwd;
  if(stricmp(os_dir,"-F8")==0){
	  pt=(char *)ReGetDir(dir,NULL,true);
	  printf("  Export: %s ...",pt? pt : rootchs);
	  if(pt)free(pt);
	  os_cwd: os_dir=(char *)"."; goto skp;
	}
  if(access(os_dir,0)==0||mkdir(os_dir
#ifdef	_STDIO_H
,0755
#endif
)==0){
  skp:  if(dscpts==NULL){
	expdec=GetManu(25);
	dscpts=(const char **)MemDiv(expdec,fmt,8);
	}
    { char buf2[1024];
	getcwd(buf2,1023);
	pt=rstrrchr(os_dir[0]=='.'&&os_dir[1]==0? buf2:os_dir,'\\', ROOT_CH);
	pt=catstr(os_dir,pt, '/');
    }
    _fnam=catstr(pt,RLS,0);	free(pt);
    if((mainfp=fopen(_fnam,"wb"))!=NULL){
	time_t t1;
	fwrite(dscpts[0], strlen(dscpts[0]),1,mainfp);
	time(&t1);
	fprintf(mainfp,dscpts[2],ctime(&t1) );
	fwrite(dscpts[7],strlen(dscpts[7]),1,mainfp);
	dirfp=mainfp;  MainDir=os_dir;
	if((*os_dir!='\\'&&*os_dir!='/')&&os_dir[1]!=':'){
	  pt=(char *)separChr(os_dir);
	  if(pt)*pt=0;
	}
	ExpDirs(send,NULL,dir);
	if( (msg&3)==0)msg=1;
	DirFullBrow(send,msg,ExpNumbs,dir,ExpDirs);
	if(dirfp&&dirfp!=mainfp)fclose(dirfp);
	fclose(mainfp);
	}
  }
  else ManuInfo(47,true);
  if(dir&&dir!=send->CurDir)free(dir);
}
else reportBug();
}
