/*
	Write & edit by Linjianghua 2005-06,2008-2011
	Copyright Linjianghua(xempo)
	Reserve all rights of this file
*/

#include "rtlproj.h"

#ifndef	_STDIO_H
#include <bios.h>
#else
#include "unix.c"
#endif
#include <stdlib.h>
#include <string.h>

int loop_depth;

bool BrowNumbs(RunTimLib *lib,int (*pro_numb)(RunTimLib *,DIRE *,BYTE *),DIRE *dir)
{
  bool rt=true;
  DirShadow *pdp=GetDirShadow(dir,lib);
  BYTE *dsb;
  pdp->_numb_=0;
  pdp->n_CSB_numb=pdp->CSB_numb;
  while((dsb=StatSeek(lib,dir,0,NULL,NUMB_STAT_BLANK))!=NULL){
      rt=pro_numb(lib,dir,dsb);
      free(dsb);

#ifndef	_STDIO_H
      if(_bios_keybrd(1)==283)return false;/* stop loop */
#endif

      if(rt==false||pdp->n_CSB_numb<1)break;
	}
  return rt;
}

/* pro_numbs or pro_dirs depend on DirFlags
DirFlags: if pro_numb null, clear 0bit. */
int DirFullBrow(RunTimLib *lib,int DirFlags,int (*pro_numb)(RunTimLib *,DIRE *,BYTE *),DIRE *pdir,int (*pro_dir)(RunTimLib *,DIRE *,DIRE *))
{
  DirStat *unit, *dsb;
  CSB_Unit *dirloop;
  int i, rt=1;
  DIRE *dir2, *dirbuf;
  if((DirFlags&1)&&BrowNumbs(lib,pro_numb,pdir)==false)return false;
  dirloop=dGetCSB_U(pdir,lib);
  if(dirloop->cur_CSB==0)return true;/*false;*/
  dirloop->nx_CSB=dirloop->cur_CSB;
  loop_depth++;  
  if(DirFlags&6 /*2|4*/ )
    while(rt&&(dsb=DirSeek(lib,pdir,(void *)SPC,DIRE_STAT_BLANK))!=NULL){
	unit=dsb;
	for(i=0;i<dirloop->cnt_unit&&rt;i++,unit++)if(unit->Flags==1){
	    dirbuf=DIRalloc();
	    dir2=DirRead(lib,dirbuf,unit,unit->pDir);
	    if(DirFlags&2)rt=pro_dir(lib,pdir,dir2);/* if rt>1, can't proc its be_Long */
	    if((DirFlags&4)&&rt==1)
		DirFullBrow(lib,DirFlags,pro_numb,dir2,pro_dir);
	    if(dir2!=lib->CurDir)DirClose(lib,dir2);
	    else free(dirbuf);
	}
	free(dsb);
      }
  loop_depth--;
return rt;
}
