/*
	Write & edit by Linjianghua(Xempo) 2004-2006
	Copyright Linjianghua(Xempo)
	Reserve all rights this file 
*/

#include <sys/stat.h>
#include "c_lib.h"
#include "calc.h"
#include "normlib.h"
#include "rtlcom.h"
#include "dire.h"
#include "script.h"
#include "filecon.h"
#include "numbio.h"

#ifndef	_STDIO_H
#include <process.h>
#include <share.h>
#include <conio.h>
#endif

#include "jxswitch.h"

extern const char *pExeNam[];
int (*popMsg)(const char *,const char *,int);
int OverW, ModeVal;
const _Int *kval,
	confval[8]={0,1,2,3,4,5,6,7}; /* GetManu in future */
char *InpBuf, Conf_val[8], out_scrn_same /* display on screen in same time  */;
/* ver format: x.x.xx */
const char RTLnam[]="runtime-lib proj",
  RLS[]=".rls", *comchs,
  libver[]="RunTime Lib console (beta2.89)",
  DPdef[]="Permission denied", OUTSCR[]="--show",
  failexe[]="Fail to exec %s";

#include "_tfd.h"
TxtDat tfd;

RunTimLib *ExecFile(RunTimLib *lib0,char **chs)
{
  char *pt, *pm=(char *)IsExec(*chs, pExeNam);
  if(pm){
    char *tmp=NULL;
    RunTimLib *lib;
    CommNumb=7001;
    lib=RTLspace(lib0, pm, 23 /* 1+2+4+16 */);
    if(pm!=*chs){
	tmp=*chs;	*chs=pm;
	}
    if(lib==NULL&&idxdscpt==1){/* 0 can't open, 1 unknow */
	if((pt=strstr(*chs,RLS))!=NULL&&stricmp(pt,RLS)==0){
		OverW=0;
		lib=RTLscript(lib0,chs,true);
	}
	else if(tmp){
		free(pm);
		*chs=tmp;
		goto _wndcmd_; /*  as input mkfs, mkfs is /sbin/mkfs,  tips is can't open, so must ...*/
		}
    }
    if(tmp)free(pm);
    if(CommNumb!=11520)CommNumb=-1;
    if(lib)return lib;
    else {
	if(idxdscpt<0x7ffd)reportBug();
	return lib0;
	}
  }
  else {
	_wndcmd_: CommNumb=-10; return lib0;
	}
}

bool ChDir(RunTimLib *lib, char *dirname,int sel)
{/* if use rt=false and use return rt, it would more large mem for use */
char *pbuf=InpBuf;
DIRE *dir1=DirOpen(lib,lib->CurDir,dirname);
if(idxdscpt>0x7ffd){
  if(dir1!=lib->CurDir){
    DirClose(lib,lib->CurDir);
    lib->CurDir=dir1;
    lib->mdf|=1;
    return true;
  }
  if(sel>0)return true;
}
else reportBug();
return false;
}

RunTimLib *Import(RunTimLib *lib,char *pcdir)
{
  char *buf1=(char *)malloc(512),  *pm[2];
  *pm=buf1+256; pm[1]=NULL;
  strcpy(*pm,rstrrchr(pcdir,'\\',ROOT_CH));
  strcat(*pm,RLS);
  getcwd(buf1,255);
  chdir(pcdir);
  FreeWMsg=true; /* bit:0&1 SET is freewrite-flag */
  OverW=0;
  lib=RTLscript(lib,pm,true);
  chdir(buf1);  free(buf1);
  return lib;
}

void showWS(RunTimLib *lib)
{
#ifdef	_STDIO_H
printf("\033[34m\n  WorkSpace: %d,   %s\n", lib->fd,lib->fname);
#else
	static const char wksp[]="\r\n  WorkSpace: %d,   %s";
	int x, y, n;
	char buf[200];
	cursorXY(&x, &y);
	n=x>1? 0:2;
	sprintf(buf, wksp+n, lib->fd,lib->fname);
	PrnTxt(x, y, strlen(buf), 1, buf);
	puts(SPC);
#endif
}

static const _Int MultSpCmd[]={/* follow can use warkspace operate */
	-306,3002,1002, 1001,1003,3000,1000,1800,1004,
	8083,8003,8005,8006,8012,
	8007,DIRE_EMPTY,N_DELS,8008,/* 8041,8043,8044,copy func(...extpm)*/
	8020,8106,8105,8108,-293,-298,
	-300,-302,-304,-308,-309,-311,-314,-318,
	-319,-301,-344,-361,0
	},
	sp_disable_cmd[]={8020,/* export */ -302/* info*/,-301/*cmpr */,
		-344,/*close*/
		8043,8044,8041/* copy */, 0};

RunTimLib *Comjxor(RunTimLib *Lib,char *inpbuf)
{
  char *pt, **lst, **pm, *extpara;
  static const char ON[]="on", OFF[]="off", separaChs[]=" \t",
  progchr[]="-File,-Numb,-Dir,-Dir|Numb,-OS,-Other";
  RunTimLib *_Lib=NULL;
  DIRE *dir;
  size_t len;
  int sel=0, i, j, n=20;
  un_Int para[4];
  _Int ncmd;
  _Long numb;
  BYTE *stat;
  MAU send;
  ncmd=GetComm(inpbuf,comchs,kval,&extpara);
  if(ModeVal!=264)ModeVal=0;/* 256|8 clear every times */
  switch(ncmd){
  case -335 : shwMsg=true; return Lib;
  case 3000 :
  case 1000 : n=3; break;
  case -293 : if(inpbuf[2]=='\\'||inpbuf[2]=='/'||inpbuf[2]=='.')inpbuf[1]=32;
  case 7032 :
  case 7031 : /* calc */
  case -391 :
  case -390 :
  case 1800 :
  case 1004 :
  case 8007 :
  case 8008 : n=2; /* break; */
/*  case 8041 : copy */
  }

  errSig_space=false;
  lst=SetArgv(inpbuf,&n,separaChs);
  if(n==2&&(j=GetComm(lst[1],"-?,/?,-h,/h",confval,NULL))!=-400||
    ncmd!=11520&&(n<2&&ncmd>-200 ||n<3&&ncmd>8099)){
    UsageMsg(ncmd);    goto _exit_;
    }
  if(ncmd==-400){
	Lib=ExecFile(Lib,lst);
/*      if(Lib1&&_Lib!=Lib){ RTLdestroy(Lib); Lib=_Lib; }*/
	if(CommNumb==-10){
		char buf[256];
		sprintf(buf,"%s: Wrong command",*lst);
		puts(buf);
		if(Conf_val[1])RunLog(buf);
		scriptTips(2);
		}
	goto _exit_; 
    }
  else {
	if( getspace(extpara,&sel,&j) && sel>0 ){
	    if(isdone(ncmd,MultSpCmd)==0){
/*		static _Int cpcmd[5]={8043,8044,8041}; */
		if(isdone(ncmd,sp_disable_cmd+5)==0)ManuInfo(64,2|1); /* no WarnStyle | no quest */
		goto _let;
		}
	    if((sel=SelSpace(sel))<1)goto _exit_;
	    _Lib=workspace[sel];
	    if(ncmd==-293){  free(lst); /* cd */
		lst=SetArgv(inpbuf+3,&n,separaChs);
		}
	}
	else _let: _Lib=Lib;
  }
  if((_Lib==NULL||_Lib->fpt==NULL)&&
	!(ncmd==11520||ncmd<-311||ncmd>6999&&ncmd<8000)){
	ManuInfo(2,true); goto _exit_;
	}
  CommNumb=ncmd;
  n--; pm=lst+1;
  switch(ncmd){
  case 7032 :
  case 7031 :{	double rt=calc(*pm);
	if(n_CalcErr)puts(_calcErr());
	else printf("%lf\n",rt);
	}
	break;
  case -334 : /* echo */
	if(n)
	  if(stricmp(*pm,ON)==0)CommNumb=-380;
	  else if(stricmp(*pm,OFF)==0)CommNumb=-381;
	break;
  case -344 : RTLdestroy(_Lib);
	if(_Lib==Lib)Lib=NULL;
	break;

  case 7030 : /* impcreat */if(_Lib)break;
  case 7002 : /* newspace */
  case 7000 : /* creat */
      FixDirPara(n-1,pm+1,para);
  for(i=0; i<SPACELIMIT && (workspace[i]==NULL ||
#ifdef	_STDIO_H
	strcasecmp(*pm,workspace[i]->fname)
#else
	strcmp(*pm,workspace[i]->fname)
#endif
); i++);

      switch(i){
      case SPACELIMIT : 
	break; /* no using */
      case 0 :  ManuInfo(50,true); CommNumb=-331; goto _exit_;
      default :	
		if(ManuInfo(15,2)!='y')goto _exit_;
		if(Lib&&Lib->fd==i)Lib=NULL; /* the creat file exist & have open */
		RTLdestroy(workspace[i]); goto _creat_;
	}
     if(*para&16384)*para^=16384;
     else if(access(*pm,6)==0){
		switch( ManuInfo(17,2) ){
		case 'y' : break;
		case 27 : CommNumb=-331;
			goto _exit_;
		default : CommNumb=-332;
			goto _exit_;
		}
		}
_creat_:      _Lib=RTLcreat(*pm, para);
     if(_Lib){
	if(putspace(_Lib,0)==false){ RTLclose(_Lib,NULL); break; }
	RTLinform(_Lib,InpBuf); puts(InpBuf);
	if(Lib){
	  if(ncmd==7002){
#ifdef	_STDIO_H
printf(curSpace,_Lib->fd);
#else
cursorXY(&i, NULL);
printf(curSpace+(i>0 ? 0:1));
#endif
	   }
	  else RTLdestroy(Lib);
	}
/*#ifndef	_STDIO_H
	GetComLst(_Lib);
#endif*/
	Lib=_Lib;
	}
      else if(idxdscpt<0x7ffd)reportBug();
      break;

  case 7020 : pt=ReadFile(*pm,&len,false);
	if(pt){ RemTok(pt); puts(pt); free(pt); }
/*	else reportBug(); */
	break;

  case -342 : 
	if(n){
	    if(isNumb(*pm)==false){ ManuInfo(45,1); UsageMsg(-342); break; }
	    i=atoi(*pm); n=i;
	    if(Lib){
		  switch(n){
		  case -20 : /* F5 */ i=Lib->fd+1; break;
		  case -22 : /* F4 */ 
			if(Lib->fd>1)i=Lib->fd-1;
			else for(i=LASTSPACE;i>1&&workspace[i]==NULL;i--);
			if(i==Lib->fd)return Lib;
			break;
		  default : goto skpsel;
		  }
		 if(i>LASTSPACE||workspace[i]==NULL){
			if(Lib->fd==1&&n==-20/* F5 */)break;
			i=1;
			}
		}
		skpsel:if(i>0&&i<SPACELIMIT&&workspace[i])Lib=workspace[i];
		else { DefaultManu(i? 48:50);	break; }
	}
	showWS(Lib);
	break;
  case -312 : getcwd(InpBuf,256); puts(InpBuf);
	break;
  case -362 : ManuInfo(41,0); break;
  case -315 : /* help */
	i=n>0? GetComm(*pm,progchr,confval,NULL):0;
	if(i>-1&&workspace[0])ManuInfo(31+i,false);
	else puts(comchs);
	break;

  case -371 : /* path, id=2*/
	if(n>0){
	  bool Sv=true;
	  i=SortPara(n,pm,&j);
	  while(i<n){
		if(stricmp(pm[i],"--cur")==0){ /* only current system setting */
			n--;
			for(j=i;j<n;j++)pm[j]=pm[j+1];
			Sv=false;
			break;
			}
		i++;
		}
	  pt=*pm;
	  if(pt[0]=='*' && pt[1]==0)pt=(char *)SPC;
	  send.buf=pt;  send.len=strlen(pt);
	  if(Sv && *workspace && NumbWrite(*workspace,NULL,2,&send,1, NUMB_SYS_ID )==NULL)
		printf("Can't write into sysId\n");
		cnt_path=0;
	  free((void *)progpath[0]);	  free((void **)progpath);
	  progpath=(const char **)envpath(*_argv, pt);
	}
	else for(i=0;i<cnt_path;i++)puts(progpath[i]);
	break;
  case -348 : mainfp=NULL;
	if(n&&stricmp(*pm,OUTSCR)==0)out_scrn_same=true;
	else puts("Detail see \"RTL.log\"");
	if((dir=DirOpen(*workspace,NULL,runLog))==NULL){
		static const un_Int params[4]={  1, 10, 4, 1 };
		dir=DirCreat(*workspace,NULL,runLog, params);
		}
	if(dir){
		char buf[20];
		j=dir->selfnumb;	i=0;
		DirClose(*workspace,dir);
		do sprintf(buf,"/Log/%d",i++);
		while( Select(*workspace,buf,NULL,-348,0)&&i<j);
	}
	out_scrn_same=false;
	break;
  case 8083 : /* newdir */
  case 8003 : /* mkdir */
/*	*para=0; Format */
/*	para[1]=10; */	/* n_stat_CSB 10 */
/*	para[2]=4; */ /*  dir_stat_CSB 4 */
	pt=FixDirPara(n,pm,para);/* return dirname */
	dir=DirCreat(_Lib,_Lib->CurDir,pt,para);
	if(dir)DirClose(_Lib,dir);
	else reportBug();
      break;
  case 8031 : Find(Lib,n,pm); break;
  case -343 : if(n==0){
		for(i=1;i<SPACELIMIT;i++)
		  if(workspace[i])printf("%s : %d\n",workspace[i]->fname,workspace[i]->fd);
		break;
		}
  case 7001 :  	if((_Lib=RTLspace(Lib,*pm,7))!=NULL)Lib=_Lib;
		break;
  case -293 : if(ChDir(_Lib,n>0? *pm:(char *)SPC,sel)){
		RunTimLib *ptr=Lib;
		Lib=_Lib;	_Lib=ptr;
		errSig_space=true;/* disable showWS */
		goto libinfo;
		}
		break;
  case -302 : showWS(_Lib);
	libinfo: if(diguei==0||shwMsg){
			RTLinform(ncmd!=-293 ? _Lib:Lib,InpBuf);
			puts(InpBuf);
			}
		break;
  case -304 : NumbUnDelete(_Lib,*pm,-304); break;
  case -298 : for(numb=0; NumbUnDelete(_Lib,*pm,-298); numb++);
		printf("Total: %ld deleted numb be discovered",numb);
		break;
  case 8106 : if(IsNumber(*pm))goto nRem;
	      else goto DirStPro;
  case 7010 : pt=(char *)IsExec(*pm, pExeNam+1);
		if(pt&&pt!=*pm)*pm=pt;/* use follow prn */
		Lib=RTLscript(Lib,pm,true); 
		if(pt&&pt!=*pm)free(pt);
		break;
  case N_DELS :
  case DIRE_EMPTY : /* empty */
  case 8007 : 
  case 8005 : if(IsNumber(*pm))goto nRem;
  case 8108 : /* dir-rename */
  case 8012 : /* rmdir */ DirStPro: dStatProc(_Lib,pm,ncmd);
	break; /* DirRemove */
  case 8105 : /* NumbRename */
  case 8006 : nRem: nStatProc(_Lib,pm,ncmd);
	break;
  case -308 : DirUnDelete(_Lib,*pm,ncmd);
	break;
  case 8041 : NumbCopy(Lib,pm,extpara);
	break;
  case 8043 : 
  case 8044 : DirCopy(Lib,n,pm,extpara,ncmd);
	break;
  case -309 : /* -309 lists; -300 list */
  case -300 : List(_Lib,n,pm,ncmd);
	break;
  case 8020 : Export(_Lib,n,pm);
	break;
  case 7009 : Lib=Import(_Lib,*pm);
	break;
  case -320 : {
	time_t t1;
	time(&t1);
	puts(ctime(&t1));
	}
	break;
  case -316 :
#ifdef	_STDIO_H
	printf("\033[2J");
#else
	clear();
#endif
	break;
  case -318 : 
	if(_Lib==NULL)_Lib=libmanu;
#ifndef	_STDIO_H
	if(_Lib&&_Lib->comlst)memset(_Lib->comlst,0,5);
#endif
/*		SaveComLst(_Lib); as free(_Lib->comlst). */
	break;
  case -319 : 
	stat=StatSeek(_Lib,NULL,1,NULL,NUMB_READ);/* remove dscpt */
	if(stat){
	  	*stat=0;
		ChgStat(_Lib,NULL,stat,_Lib->statpos,-1,1);
		free(stat);
	}
	break;
  case -373 : 
	if(_Lib==NULL)_Lib=libmanu;
	switch(n){
	case 0 : printf("limited size:%d K, limited persent:%d",_Lib->CmprSiz,_Lib->CmprPer); break;
	case 2 : _Lib->CmprPer=atoi(pm[1]);
	case 1 : _Lib->CmprSiz=atoi(*pm);
		_Lib->mdf|=1;
	}
	break;
  case -314 : puts(libver); puts(libCode); break;

/*------------------------------------------------------------------*/
  case -391 : /* config */
  case -390 : if(n==0){/* autoexec */
		if((pt=sysIdRead(*workspace, ncmd+394))!=NULL)
			{ puts(pt); free(pt); }
		}
	      else {
		putMAU(&send,*pm,_sold);
		NumbWrite(*workspace,NULL,ncmd+394,&send,1, NUMB_SYS_ID);
		}
		break;
  case 8008 :/* setdscpt */ {
	MAU *snd=MAUalloc(_Lib->_DAU);
	putMAU(snd,*pm,_txt/* type */);
	NumbWrite(_Lib, NULL,1, snd,1, NUMB_SYS_ID );
	free(snd);
	}
    	break;
  case 1000 :
  case 3000 : ncmd=1000;
  case  NUMB_SYS_ID :
  case 1800 : 
  case 1004 : NumbIns(_Lib,pm,extpara,ncmd);
	break;
  case -311 : 
	if( (pt=sysIdRead(_Lib,1))!=NULL ){
		puts(pt);	free(pt);
		}
	break;
  case 1040 : /* out to file */
  case 3002 : 
  case 1002 : Select(_Lib,*pm,extpara,ncmd,0); break;
/*------------------------------------------------------------------*/
  case -365 : 
#ifndef	_STDIO_H
	if(spawnvpe(P_WAIT, *pm, pm, progpath)==-1)printf(failexe,*pm);
#endif
	break;
  case 1003 :
  case 1001 : memset(&tfd,0,sizeof(TxtDat));
	CreatTD(&tfd,*pm,5);
  case -299 :
  case -305 : TxtImpor(_Lib,pm[1],ncmd);	break;
  case -301 :
	if(_Lib){
		if(n&&stricmp(*pm,"-F9")==0)goto showString;
		i=6;
	skpcmpr: j=_Lib==Lib;
		_Lib=Compress(_Lib,*pm,extpara,i);
		if(j||Lib==NULL)Lib=_Lib;
	}
	else {
		_Lib=RTLinstance(*pm,10); 
		if(_Lib){ 
		showString: i=262; *pm=NULL;
		goto skpcmpr;
		}
/*		else { ManuInfo(2,1); break; }*/
		}
	if(i==6&&j)goto libinfo;
	break;
/*  case -363 : FreeWMsg|=2;  break; */
  case -346 : 
	for(i=1;i<SPACELIMIT;i++)if(workspace[i])RTLdestroy(workspace[i]);
	Lib=NULL;	break;
  case -313 : ManuInfo(I_Readme,false); break;
  case -306 : {
    char *fmt, *fmt1, *ModeScpt;
    for(i=0;i<n&&stricmp(pm[i],"-d");i++);
    if(i<n){ pt=i==0? pm[1]:*pm; i=38; }
    else { pt=*pm; i=37; }
    dir=DirOpen(_Lib,_Lib->CurDir,pt);
    if(idxdscpt>0x7ffd){
	DirShadow *pdp=GetDirShadow(dir,_Lib);
	if((fmt=GetManu(i))!=NULL){
	  if((fmt1=strchr(fmt,1))!=NULL){
	     time_t t1;
	     time(&t1);
	     *fmt1++=0;
	     if((ModeScpt=strchr(fmt1,1))!=NULL)*ModeScpt++=0;
	     pt=(char *)ReGetDir(dir,NULL,1);
	     printf(fmt,pt?pt:rootchs,ctime(&t1),
		pdp->sz,pdp->num_stats_block,pdp->selfnumb);
	     printf(fmt1,pdp->dir_stats_block,pdp->selfdir,
	     	isZero(pdp->Format) ? "Zero" : "Numb", pdp->_DAU,ModeScpt);
	     if(pt)free(pt);
	  }
	  free(fmt);
	}
	if(dir&&dir!=_Lib->CurDir)free(dir);
    }
    else reportBug();
  }
  break;
  }
_exit_:  if(lst)free(lst);
  if(sel>0&&isdone(ncmd,sp_disable_cmd)==false&&_Lib&&_Lib!=Lib){
	if(errSig_space==false)showWS(_Lib);
	}
  return Lib;
}
